* GUT, J.A.W. Programao Matemtica para Otimizao de Processos. EDUSP 2021.
* https://sites.usp.br/otimizacao/
***** Problema de transporte ******************************
***** Definio de conjuntos ******************************
SET i fbricas / palmas, campo-grande /;
SET j centros / sao-paulo, belo-horizonte, salvador /;
***** Definio de parmetros *****************************
PARAMETER ct custo transporte / 0.053 / ;
PARAMETER cp(i) capacidade
         / palmas       1500
           campo-grande 1500 /;
PARAMETER ci capacidade total;
ci = SUM(i,cp(i));
PARAMETER dm(j) demanda
         / sao-paulo      900
           belo-horizonte 700
           salvador       800 /;
TABLE ds(i,j) distncias
                       sao-paulo  belo-horizonte salvador
         palmas        1.8        1.5            1.4
         campo-grande  1.0        1.3            2.5 ;
***** Declarao de variveis *****************************
FREE VARIABLE f objetivo;
POSITIVE VARIABLE x(i,j) quantidade;
***** Declarao de equaes ******************************
EQUATION h0 objetivo, h(j) demanda, g(i) capacidade;
***** Equaes ********************************************
h0.. f - ct*SUM((i,j),ds(i,j)*x(i,j)) =E= 0;
h(j).. SUM(i,x(i,j)) - dm(j) =E= 0;
g(i).. SUM(j,x(i,j)) - cp(i) =L= 0;
***** Soluo do problema *********************************
MODEL transporte /ALL/;
SOLVE transporte USING LP MINIMAZING f;
***********************************************************

